#!/usr/local/bin/perl -w
# $Id: mam.pl,v 0.1.0 1999/09/21 21:49:57 philip Exp philip $	
# Author: Philip Jacob <pjacob@screamdesign.com>
# Description: mod_auth_mysql user/group manager.
# This is released under the GPL.

##################################################
#Import modules.
##################################################
use strict;
use DBI;
use CGI;
#use lib ("/path/to/directory/");
use Scream::DBWrap;
use vars qw ($CGI $DBH);

##################################################
#Configuration.
##################################################
my (%config) = (
		"datasource"  => "dbi:mysql:http_auth",
		"username"    => "http_auth",
		"password"    => "4uthorize"
		);

my $group_table = "mysql_auth_groups";
my $user_table  = "mysql_auth";

##################################################
#Setup and initialization.
##################################################
$CGI = new CGI;
$DBH = &screamconnect(\%config);
my $stage = $CGI->param('stage') ? $CGI->param('stage') : "";


##################################################
#Program Logic.
##################################################

if ($stage eq "drawleft") {
    &drawleft($user_table, $group_table);

} elsif ($stage eq "viewgroup") {
    &viewgroup($user_table, $group_table);

} elsif ($stage eq "addgroup") {
    &addgroup($user_table, $group_table);

} elsif ($stage eq "deletegroup") {
    &deletegroup($user_table, $group_table);

} elsif ($stage eq "viewuser") {
    &viewuser($user_table, $group_table);

} elsif ($stage eq "adduser") {
    &adduser($user_table, $group_table);

} elsif ($stage eq "updateuser") {
    &updateuser($user_table, $group_table);

} elsif ($stage eq "deleteuser") {
    &deleteuser($user_table, $group_table);

} elsif ($stage eq "changepasswd") {
    &userpasswd($user_table, $group_table);

} elsif ($stage eq "groupupdate") {
    &updategroups($user_table, $group_table);
    
} else {
    &default;
}

$DBH->disconnect if $DBH;

##################################################
#Subroutines.
##################################################

sub addgroup {
    my ($user_table, $group_table) = @_;

    my ($sql) = "insert into $group_table (username, groups) values ('', " . $DBH->quote( $CGI->param('group') ) . ")";
    my ($sth) = &screamsql($DBH, $sql);

    #This may be wrong.
    my ($url) = "http://" . $CGI->server_name . $CGI->script_name . "?stage=drawleft";

    #Make the group var safe for the hidden field.
    my ($safe_group) = $CGI->escapeHTML( $CGI->param('group') );

    #Confirmation.
    print
	$CGI->header,
	$CGI->start_html(-title  => "Added a group!",
			 -onLoad => "parent.left.location.href='$url'"),
	$CGI->h1('Group addition successful'),
	"The group ", $CGI->b( $CGI->param('group') ), " was added.  You may need to force a refresh of the left frame if it didn't automatically.",
	$CGI->p,
	$CGI->startform("POST",
			'',
			'',
			'target=right',),
	$CGI->submit(-name    => '',
		     -value   => "Edit the new group!"),
	"<input type=hidden name=group value=\"$safe_group\">",
	"<input type=hidden name=stage value=viewgroup>",
	$CGI->endform,
	$CGI->end_html;
}


sub adduser {
    #Adds a silly little user.
    my ($user_table, $group_table) = @_;
    
    my ($sql) = "insert into $user_table (username, passwd) values (" . $DBH->quote( $CGI->param('username') ). ", " . $DBH->quote( $CGI->param('password') ) . ")";
    my ($sth) = &screamsql($DBH, $sql);
    
    #This may be wrong.
    my ($url) = "http://" . $CGI->server_name . $CGI->script_name . "?stage=drawleft";

    #Confirmation.
    print
	$CGI->header,
	$CGI->start_html(-title  => "Added a user!",
			 -onLoad => "parent.left.location.href='$url'"),
	$CGI->h1('User addition successful'),
	"The user ", $CGI->b( $CGI->param('username') ), " was added.  You may need to force a refresh of the left frame if it didn't automatically.",
	$CGI->p,
	$CGI->startform("POST",
			'',
			'',
			'target=right',),
	$CGI->submit(-name    => '',
		     -value   => "Edit the new user!"),
	"<input type=hidden name=user value=", $CGI->param('username'), ">",
	"<input type=hidden name=stage value=viewuser>",
	$CGI->endform,
	$CGI->end_html;
}


#Change user password.
sub userpasswd {
    my ($user_table, $group_table) = @_;

    #Just issue an update statement unless there is more than one user.
    my ($sql) = "select username from $user_table where username = " . $DBH->quote( $CGI->param('user') );
    my ($sth) = &screamsql($DBH, $sql);
    if ($sth->rows > 1) {
	print 
	    $CGI->header,
	    $CGI->start_html,
	    $CGI->h2("Error:"),
	    "The username ", $CGI->b( $CGI->param('user') ) , " is represented " , $sth->rows , " times in the $user_table table in your database.",
	    $CGI->p,
	    "This is not a good thing at all, since the username column of this database should have a key on it, thus preventing non-unique usernames.",
	    $CGI->p,
	    "The operation to change the password for this user failed.",
	    $CGI->end_html;

    } else {
	my ($sql) = "update $user_table set passwd = " . $DBH->quote( $CGI->param('password') ) . " where username = " . $DBH->quote( $CGI->param('user') );
	my ($sth) = &screamsql($DBH, $sql);
																	
	#Get the magic screen set up.
	&viewuser($user_table, $group_table);
	
    }

}


sub deletegroup {
    my ($user_table, $group_table) = @_;
    
    my ($sql) = "delete from $group_table where groups = " . $DBH->quote( $CGI->param('group') );
    my ($sth) = &screamsql($DBH, $sql);

    #This may be wrong.
    my ($url) = "http://" . $CGI->server_name . $CGI->script_name . "?stage=drawleft";

    #Confirmation.
    print 
	$CGI->header,
	$CGI->start_html(-onLoad => "parent.left.location.href='$url'"),
	$CGI->h1('Group deleted successfully: ', $CGI->param('group')),
	"The group, along with all members was deleted.",
	$CGI->end_html;
}


sub deleteuser {
    #Get the user and group tables.
    my ($user_table, $group_table) = @_;

    #Delete from the user table first.
    my ($sql) = "delete from $user_table where username = " . $DBH->quote( $CGI->param('user') );
    my ($sth) = &screamsql($DBH, $sql);
    
    #Delete from the groups table.
    $sql = "delete from $group_table where username = " . $DBH->quote( $CGI->param('user') );
    $sth = &screamsql($DBH, $sql);
    $sth->finish if $sth;
    
    #This may be wrong.
    my ($url) = "http://" . $CGI->server_name . $CGI->script_name . "?stage=drawleft";

    #Confirmation.
    print
	$CGI->header,
	$CGI->start_html(-title  => "Deleted a user!",
			 -onLoad => "parent.left.location.href='$url'"),
	$CGI->h1('User deletion successful'),
	"The user ", $CGI->b( $CGI->param('user') ), " was deleted.  You may need to force a refresh of the left frame if it didn't automatically.",
	$CGI->end_html;
    
}


#Update group perms for a given user.
sub updateuser {
    #Get those magic tables.
    my ($user_table, $group_table) = @_;
    
    #Make this user a member in these groups.
    my (@groups) = $CGI->param('groups');

    #Delete all group memberships for this user.
    my ($sql) = "delete from $group_table where username = " . $DBH->quote( $CGI->param('user') );
    my ($sth) = &screamsql($DBH, $sql);    

    #Since we're doing a bunch of inserts, prepare the statements first.
    my ($p_sth) = $DBH->prepare("insert into $group_table (username, groups) values (?, ?)");

    foreach my $group (@groups) {
	#Then, add permissions for this user.
	$p_sth->execute($CGI->param('user'), $group );
    }
    $p_sth->finish if $p_sth;
    $sth->finish if $sth;    

    #Take the user back to the same screen showing user profile.
    &viewuser($user_table, $group_table);
}


#Update the group tables with this new data.
sub updategroups {
    #Get the names of the tables we're working with.
    my ($user_table, $group_table) = @_;

    #Find out whether we're doing an update or a delete.
    if ($CGI->param('add')) {
	my ($sql) = "select username from $group_table where username = " . $DBH->quote( $CGI->param('users') ) . " and groups = " . $DBH->quote( $CGI->param('group') );
	my ($sth) = &screamsql($DBH, $sql);
	unless ($sth->rows) {
	    $sql = "insert into $group_table (username, groups) values (" . $DBH->quote( $CGI->param('users') ) . ", " . $DBH->quote( $CGI->param('group') ) . ")";
	    $sth = &screamsql($DBH, $sql);
	}
	$sth->finish if $sth;
	
    } elsif ($CGI->param('delete')) {
	my ($sql) = "delete from $group_table where username = " . $DBH->quote( $CGI->param('members') ) . " and groups = " . $DBH->quote( $CGI->param('group') );
	my ($sth) = &screamsql($DBH, $sql);
	$sth->finish if $sth;
	
    }

    #Take the user back to the same screen showing the users list and groups list.
    &viewgroup($user_table, $group_table);
}


#Display's a group's information.
sub viewgroup {
    #Get the names of the user and group tables.
    my ($user_table, $group_table) = @_;
    
    my (@members, @users);
    
    if ($CGI->param('group')) {
	#Get the group's members.
	my ($ref_members) = &getusers($user_table, $group_table, $CGI->param('group'));
	@members = @$ref_members;
	
	#Get a list of all users.
	my ($ref_users) = &getusers($user_table, $group_table);
	@users = @$ref_users;
	
    } else {
	#Print out a warning saying there was no group selected.
	print 
	    $CGI->header,
	    $CGI->h1('You did not select a group!');
	
    }

    #Get the group value nice and safe.
    my ($safe_group) = $CGI->escapeHTML( $CGI->param('group') );

    #Get the group's data up, if a group was selected.
    print 
	$CGI->header,
	$CGI->start_html,
	$CGI->startform("POST",
			'',
			'',
			'target=right',),
	"<input type=hidden name=stage value=groupupdate>",
	"<input type=hidden name=group value=\"$safe_group\">",
	$CGI->h1('Group Profile: ', $CGI->param('group')), 
	"On the left, members of the current group are shown.  On the right, all users are shown.  Add and remove users by selecting their names and clicking the arrows.  Finally, hit the submit button.",
	$CGI->br,
	$CGI->table({-border=> 1 },
		    $CGI->th({-bgcolor => "#CCCCCC"}, ['Group Members', 'All Users']),
		    $CGI->Tr(
			     {-align  => "LEFT",
			      -valign => "TOP"},
			     [
			      $CGI->td(
				       {-align  => "CENTER",
					-valign => "MIDDLE"},
				       [
					$CGI->submit(-name    => 'delete',
						     -value   => '-->',
						     -onClick => ""),
					$CGI->submit(-name    => 'add',						     
						     -value   => '<--',
						     -onClick => ""),
					]
				       ),
			      
			      $CGI->td(
				       [
					$CGI->scrolling_list(-name => 'members',
							     -values => \@members,
							     -default => '',
							     -size => 15,
							     -multiple => 0),
					$CGI->scrolling_list(-name => 'users',
							     -values => \@users,
							     -default => '',
							     -size => 15,
							     -multiple => 0)
					]
				       )
			      ], 
			     ),
		    )
	    ,		 
	    $CGI->endform,
	    $CGI->startform("POST",
			    '',
			    '',
			    'target=right',),
	    $CGI->h1('Delete this group'),
	    "<input type=hidden name=stage value=deletegroup>",
	    "<input type=hidden name=group value=\"$safe_group\">",
	    $CGI->submit(-name    => '',
			 -value   => "Delete the group?",
			 -onClick => "return confirm('Really delete this group? This will delete all members of the current group as part of the process.')"),
	    $CGI->endform,
	    $CGI->end_html if $CGI->param('group');
}


#Displays a user's information.
sub viewuser {
    #Get the name of the user table and the group table.
    my ($user_table, $group_table) = @_;
    my ($username) = $CGI->param('user');

    my (@users_groups, @all_groups, $passwd);
    if ($username) {
	#Get the user's information from the database.
	my ($ref_groups) = &getgroups($group_table, $username);
	@users_groups = @$ref_groups;
	
	#Get a list of all groups.
	my ($ref_all_groups) = &getgroups($group_table);
	@all_groups = @$ref_all_groups;
	
	#Get the user's password too.
	my $sql = "select distinct passwd from $user_table where username = " . $DBH->quote($username);
	my $sth = &screamsql($DBH, $sql);
	$passwd = $sth->fetchrow_array;
	
    } else {
	#Print out a warning message if there was no user selected.
	print 
	    $CGI->header, 
	    $CGI->start_html, 
	    $CGI->h1('You did not select a user!'),
	    $CGI->end_html;

    }

    #Get a nice quoted version of username for form hidden fields.
    my $safe_username = $CGI->escapeHTML( $username );

    #Print out the user profile screen, if a user was selected.
    print 
	$CGI->header,
	$CGI->start_html,
	$CGI->h1( "User Profile:", $CGI->param('user') ),
	"The user belongs to the following selected groups:",
	$CGI->startform("POST",
			'',
			'',
			'target=right'),
	"<input type=hidden name=stage value=updateuser>",
	"<input type=hidden name=user value=\"$safe_username\">",
	$CGI->scrolling_list(-name     => "groups",
			     -values   => \@all_groups,
			     -default  => \@users_groups,
			     -multiple => 1),
	$CGI->br,
	$CGI->submit(-name  => '',
		     -value => "Update group memberships for $username"),
	$CGI->endform,
	$CGI->startform("POST",
			'',
			'',
			'target=right'),
	"<input type=hidden name=stage value=changepasswd><input type=hidden name=user value=\"$safe_username\">",
	$CGI->br,
	"The user's password is displayed below.  To change it, type the new password in the box and hit the button.",
	$CGI->br,
	$CGI->textfield(-name      => "password",
			-value     => $passwd,
			-size      => 20,
			-maxlength => 20),
	$CGI->br,
	$CGI->submit(-name => '',
		     -value => "Change password for $username"),
	$CGI->endform,
	$CGI->br,
	$CGI->startform("POST",
			'',
			'',
			'target=right'),
	"To delete this user (and all associated group memberships), hit the button.<input type=hidden name=stage value=deleteuser><input type=hidden name=user value=\"$safe_username\">",
	$CGI->br,
	$CGI->submit(-name    => '',
		     -value   => "Delete $username?",
		     -onClick => "return confirm('Really delete $username?')" ),
	$CGI->endform,
	$CGI->end_html if $username;
}


#Prints out the default frameset.
sub default {
    print $CGI->header;
    print <<__FRAMESET__;
<html>
<head>
<title>MAM: Mod_auth_mysql Account Manager</title>
</head>
<script language="JavaScript">
    document.writeln('<frameset cols="250,*">');
    document.writeln('<frame name="left" src="mam.pl?stage=drawleft">')
    document.writeln('<frame name="right" src="http://mam.screamdesign.com/">')
    document.writeln('</frameset>')
</script>
  <noscript>
      You must have JavaScript enabled!
  </noscript>
</html>
__FRAMESET__

    print $CGI->end_html;
}


sub drawleft {
    #Args.
    my ($user_table, $group_table) = @_;
    
    #Get a list of users in the database.
    my ($ref_users) = &getusers($user_table, $group_table);
    my (@users) = @$ref_users;
    my (%users);
    foreach my $element (@users) {
	my $keyelement = $element;
	$keyelement =~ s/\+/ /g;
	$users{$element} = $keyelement;
    }

    #Get a list of group in the database.
    my ($ref_groups) = &getgroups($group_table);
    my (@groups) = @$ref_groups;
    my (%groups);
    foreach my $element (@groups) {
	my $keyelement = $element;
	$keyelement =~ s/\+/ /g;
	$groups{$element} = $keyelement;
    }
    
    #Javascript string replacement thing.
    my ($javascript) = <<__JS__;
function replaceString(oldS,newS,fullS) {
// Replaces oldS with newS in the string fullS
   for (var i=0; i<fullS.length; i++) {
      if (fullS.substring(i,i+oldS.length) == oldS) {
         fullS = fullS.substring(0,i)+newS+fullS.substring(i+oldS.length,fullS.length)
      }
   }
   return fullS
}
__JS__

    print 
	$CGI->header, 
	$CGI->start_html(-script => $javascript), 
	$CGI->startform("POST", 
			'',
			'',
			'target=right'),
	"<input type=hidden name=stage value=viewuser>",
	$CGI->h1("Users:"),
	$CGI->scrolling_list(-name     => "user",
			     -values   => \@users,
			     -default  => '',
			     -size     => 8,
			     -multiple => 0,
			     -labels   => \%users,
			     -onChange => "if (parent.left.document.forms[0].user.options[selectedIndex].value) { parent.right.document.location='mam.pl?stage=viewuser&user=' + parent.left.document.forms[0].user.options[selectedIndex].value } "),
	$CGI->br,
	#$CGI->submit(-name  => '',
	#	     -value => 'Go to user profile'),
	$CGI->endform,	
	$CGI->startform("POST", 
			'',
			'',
			'target=right'),
	$CGI->submit(-name    => '',
		     -value   => "Add a new user",
		     -onClick => "var username = prompt('Enter a username to add:', ''); if (!username) { alert ('Please specify a username!');  return false; } var password = prompt('Enter a password for ' + username, ''); if (!password) { alert ('Bad password!'); return false; } password = replaceString(' ', '+', password); username = replaceString(' ', '+', username); parent.right.document.location.href='mam.pl?stage=adduser&username=' + username + '&password=' + password; return false;"),
        $CGI->endform,
	
        $CGI->startform("POST", 
			'',
			'',
			'target=right'),
	"<input type=hidden name=stage value=viewgroup>",
	$CGI->p,
	$CGI->h1("Groups:"),
	$CGI->scrolling_list(-name     => "groups",
			     -values   => \@groups,
			     -default  => '',
			     -size     => 8,
			     -multiple => 0,
			     -labels   => \%groups,
			     -onChange => "if (parent.left.document.forms[2].groups.options[selectedIndex].value) { parent.right.document.location.href='mam.pl?stage=viewgroup&group=' + parent.left.document.forms[2].groups.options[selectedIndex].value }"),
	$CGI->br,
	#$CGI->submit(-name  => '',
	#	     -value => 'Go to group profile'),
	$CGI->endform,	
	
	$CGI->startform("POST", 
			'',
			'',
			'target=right'),
	$CGI->submit(-name    => '',
		     -value   => "Add a new group",
		     -onClick => "var group = prompt('Enter the new groupname:', ''); if (group) { group = replaceString(' ', '+', group); parent.right.document.location.href='mam.pl?stage=addgroup&group=' + group; } else { return false; } return false;"),
	$CGI->endform,
	
	$CGI->end_html;
}


sub getgroups {
    my ($group_table, $user) = @_;
    my ($q_user) = $DBH->quote( $user );

    #Get a list of group in the database.
    my $sql = "select distinct groups from $group_table ";
    $sql .= " where username = $q_user" if $user;
    $sql .= " order by groups";

    my $sth = &screamsql($DBH, $sql);
    my (@groups); 
    while (my $group = $sth->fetchrow_array) {
	$group =~ s/\s/+/g;
	push @groups, $group;
    }

    return \@groups;
}


sub getusers {
    #Get all users, or just users in a certain group.
    my ($user_table, $group_table, $group) = @_;

    my ($sql);
    if ($group) {
	$sql = "select username from $group_table where groups = " . $DBH->quote( $group ) . " order by username";
    } else {
	$sql = "select username from $user_table order by username";
    }
    my ($sth) = &screamsql($DBH, $sql);
    my (@users);
    while (my $ref = $sth->fetchrow_hashref) {
	$ref->{username} =~ s/\s/+/g;
	push @users, $ref->{username};
    }
    $sth->finish if $sth;

    #Return an array reference to a list of users.
    return \@users;
}



